/*
                 THE HILBERT CLASS LIBRARY                        
                Release 0.8, September 1997                       
                                                                  
       copyright (C) 1995, 1996, 1997 by Mark S. Gockenbach,      
              Matthew Petro, and William W. Symes                 
                                                                  
The source code contained in this file FREE SOFTWARE; you can
redistribute it and/or modify it under the terms of the GNU Library
General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later
version.

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

A copy of the GNU Library General Public License resides in the root
directory of this package, as LICENSE.html, and can be viewed
conveniently with most web browsers, or less conveniently as an ASCII
text file. To receive a printed copy contact the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

#include "HCL_Arch_d.h"

double abs( double a )
{
   return a<0?-a:a;
}

double max( double a,double b )
{
   return a<b?b:a;
}

double min( double a,double b )
{
   return a<b?a:b;
}

double max( double a,double b,double c )
{
   return a>b?max(a,c):max(b,c);
}

double min( double a,double b,double c )
{
   return a<b?min(a,c):min(b,c);
}

int max( int a,int b )
{
   return a<b?b:a;
}

int min( int a,int b )
{
   return a<b?a:b;
}

int max( int a,int b,int c )
{
   return a>b?(a>c?a:c):(b>c?b:c);
}

int min( int a,int b,int c )
{
   return a<b?(a<c?a:c):(b<c?b:c);
}
