// Shannon Scott   5/10/1999
// Matrix parent class
// This class is no longer quite so abstract.  The methods provide a
// basic set of matrix manipulations.  These will probably be slower
// than the corresponding methods of the child classes.


#ifndef _MATRIX_H
#define _MATRIX_H

//#include "mat_inc_d.H"


class Matrix_d
{
public:
  Matrix_d(void){};
  virtual ~Matrix_d(void){};

  //***************************************************
  // Required (abstract) methods
  virtual int numRows(void) const = 0;
  virtual int numCols(void) const = 0;

  // Let's see if this works
  virtual double  operator()(int i, int j) const = 0;
  virtual double& operator()(int i, int j) = 0;
  
  virtual double get(int i, int j) const = 0;
  virtual void   set(int i, int j, double val) = 0;

  //***************************************************
  // General methods
  /*virtual int zero(void)           { setAll( 0.0 ); };
  virtual int ones(void)           { setAll( 1.0 ); ;
  virtual int setAll(double val);
  //virtual int diag(void);

  // Current matrix becomes A
  virtual int set(const Matrix_d& A);

  // Current matrix becomes transpose of A
  virtual int trans(const Matrix_d& A);
  
  // Add B to current matrix
  virtual int add(const Matrix_d& B);

  // Current matrix becomes A+B
  virtual int add(const Matrix_d& A, const Matrix_d& B);

  // Current matrix becomes A*B
  virtual int mult(const Matrix_d& A, const Matrix_d& B);
  */
};

#endif
