// Shannon Scott
// 6/8/1999, 6/8/99, 7/16
// Test the matrix classes

//#include "general_d.H"
#include "mat_inc_d.H"

/*void pause(void)
{
  cout << "Press <Return> to continue";
  cout << flush;
  cin.get();
  cout << endl;
}*/

//****************************************************************************
int main(void)
{
  BandedMatrix_d A(5,5,2,1);
  A.zero();
  cout << A << endl;
  A(1,1) = 1;
  A(1,2) = 2;
  A(1,3) = 3;
  A(2,1) = 4;
  A(2,2) = 5;
  A(2,3) = 6;
  A(2,4) = 7;
  A(3,2) = 8;
  A(3,3) = 9;
  A(3,4) = 10;
  A(3,5) = 11;
  A(4,3) = 12;
  A(4,4) = 13;
  A(4,5) = 14;
  A(5,4) = 15;
  A(5,5) = 16;
  cout << "A = " << endl << A << endl;
  
  GeneralMatrix_d X(5,2);
  X.ones();
  X(1,2) = 2;
  X(2,1) = 3;
  X(4,1) = 4;
  X(2,2) = 5;
  X(5,2) = 6;
  cout << "X = " << endl << X << endl;  

  GeneralMatrix_d Y(5,2);
  Y.zero();
  Y.multTrans(A, X);
  cout << "Y = A*X = " << endl << Y << endl;
  
  //*************************************
  /*// Test the symmetric matrix class
  GenSymMatrix_d A(4,4);
  A.zero();
  A(1,1) = 1;
  A(2,1) = 3.4;
  A(3,2) = 4.5;
  A(4,3) = 5.6;
  cout << "A = " << endl << A << endl;

  GeneralMatrix_d X(4,2);
  X.ones();
  X(1,2) = 2;
  X(2,1) = 3;
  X(4,1) = 4;
  X(2,2) = 5;
  cout << "X = " << endl << X << endl;

  GeneralMatrix_d Y(4,2);
  Y.mult(A, X);
  cout << "Y = A*X = " << endl << Y << endl;*/

  //*************************************************
  /*cout << "Create Matrix A" << endl;
  GeneralMatrix_d A(4,4);
  A.diag(3.4);
  A.set(1, 2, 1.2);
  A(1,3) = 5.6;
  cout << A << endl;

  // One version of submatrix manipulation
  GeneralMatrix_d B(2,2);
  B.ones();
  A.set(Index(2,2,4), Index(1,2,3), B);
  cout << A << endl;

  // Another version of submatrix manipulation
  SubMatrix C( A, Index(3,1,4), Index(3,1,4) );
  C.setAll( -1.0 );
  cout << A << endl;*/

  
  /*cout << "Create matrix B" << endl;
  GeneralMatrix_d B(4,4);
  B.ones();
  cout << B << endl;

  cout << "Create matrix C = A + B" << endl;
  GeneralMatrix_d C(4,4);
  C.add(A, B);
  cout << C << endl;

  pause();
  
  cout << "Create matrix D" << endl;
  GeneralMatrix_d D(4,4);
  D.setAll(-1.0);
  D(2,1) = 1.0;
  D(1,4) = 3.4;
  cout << D <<endl;

  cout << "Add C to D" << endl;
  D.add( (Matrix&)C );
  cout << D << endl;

  pause();
  
  cout << "Create matrix E (3 x 3), try to add it to D (4 x 4)" << endl;
  GeneralMatrix_d E(3,3);
  E.add(D);
  cout << E << endl;

  pause();
  
  cout << "Test Sub Matrix capabilities" << endl;
  GeneralMatrix_d F(2,2);
  F.overWrite(D, Index(1,1,2), Index(1,1,2));
  cout << F << endl;

  cout << "Test Sub Matrix capabilities" << endl;
  GeneralMatrix_d G(4,4);
  G.ones();
  G.overWriteSubMatrix(Index(2,2,4), Index(2,2,4), F);
  cout << G << endl;

  pause();
  
  cout << "Test multiplication (C = A * B)" << endl;
  GeneralMatrix_d H(4,4);
  H.mult(D, G);
  cout << H << endl;*/

  //***********************************************
  // Test LU decomposition
  /*cout << "Test solution of linear system" << endl;
  GeneralMatrix_d J(3,3);
  J(1,1) = 1;  J(1,2) = 2; J(1,3) = 3;
  J(2,1) = -1; J(2,2) = 0; J(2,3) = 2;
  J(3,1) = 0;  J(3,2) = 1; J(3,3) = 1;
  cout << "System to be solved: " << endl;
  cout << J << endl;
  
  GeneralMatrix_d b(3,2);
  b.ones();
  b(2,2) = 0;
  cout << "Right-hand side: " << endl;
  cout << b << endl;
  
  GeneralMatrix_d x(3,2);
  J.solve(x, b);
  cout << "Solution: " << endl;
  cout << x << endl;

  cout << "Factors of the system" << endl;
  UpperTriangle_d U(3,3);
  LowerTriangle_d L(3,3);
  Permutation     P(3,3);
  J.LU(U, L, P);

  cout << "U = " << endl;
  cout << U << endl;
  cout << "L = " << endl;
  cout << L << endl;
  cout << "P = " << endl;
  cout << P << endl;

  cout << "Solve the system using the factorization" << endl;
  GeneralMatrix_d z(3,3);
  P.solve(x, b);
  L.solve(x, x);
  U.solve(x, x);  
  cout << "Solution: " << endl;
  cout << x << endl;

  cout << "Condition numbers: inf = " << J.condInf();
  cout << ", ones = " << J.condOnes() << endl;*/

  /*  //***************************************************
  // Test QR decomposition
  GeneralMatrix_d A(4,3);
  A(1,1) = 1; A(1,2) = -1; A(1,3) = 4;
  A(2,1) = 1; A(2,2) = 4;  A(2,3) = -2;
  A(3,1) = 1; A(3,2) = 4;  A(3,3) = 2;
  A(4,1) = 1; A(4,2) = -1; A(4,3) = 0;
  cout << "System matrix A = " << endl << A << endl;

  GeneralMatrix_d Q(4,3);
  GeneralMatrix_d R(4,3);

  A.QR(Q, R);

  cout << "Q = " << endl << Q << endl;
  cout << "R = " << endl << R << endl;

  GeneralMatrix_d Rs(R, Index(1,1,3), Index());
  cout << Rs << endl;
  GeneralMatrix_d Aqr(4,3);
  Aqr.mult(Q, Rs);
  cout << "Q * R = " << endl << Aqr << endl;*/
  
  return 0;
}





