
# copyright Stanford Exploration Project.  See GNU public license.
#
# This file is part of SEP's set of GNU make rules for painless compilation
# This file overrides defaults that are incorrect for the SUN4 architecture
#
${RULES}/Prg.defs.SUN4: ; 

### C DEFINITIONS ###

# C compiler
CC = gcc

# C loader (f77 can link with F77 SEPlib routines)
#CLD = f77 
CLD = gcc


#C Flags
#CFLAGS = -Bstatic
CFLAGS = 

#+C++ compiler
C++ = g++

# C++ loader
C++LD = g++

C++LDOPTS = ${UC++LDFLAGS} ${OC++LDFLAGS} $(addprefix -L,${UC++LIBDIR} ${OC++LIBDIR}) ${UC++LIB} ${OC++LIB} -L/usr/lang/lib -lF77 -L/usr/lang/SC3.0.1/lib -lansi -lsunmath -lcx /usr/lang/SC3.0.1/lib/values-Xa.o 

### F77 DEFINITIONS ###

# shortfor folds long FORTRAN lines at column 72
FIXNULL = |shortfort

#f77 flags
F77FLAGS =

# f77 compiler
F77 = f77 -u -cg92 -fast 

# f77 loader 
F77LD = f77 -cg92 -fast

# defines libraries
# do we need to include again the lang directories? 

F77LIB  = -lf77
F77LIB2 = -lf77
F77LIB3 = -lf77
F77LIB4 = -lf77

